Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3337)
@@ -6166,6 +6843,6 @@
 
 !--         deallocate temporary arrays
-            DEALLOCATE( csflt )
-            DEALLOCATE( kcsflt )
+            DEALLOCATE( csflt_l )
+            DEALLOCATE( kcsflt_l )
             DEALLOCATE( icsflt )
             DEALLOCATE( dcsflt )
@@ -6174,10 +6851,10 @@
 
 !--         sort csf ( a version of quicksort )
-!             CALL radiation_write_debug_log( 'Sort csf' )
+            CALL radiation_write_debug_log( 'Sort csf' )
             CALL quicksort_csf2(kpcsflt, pcsflt, 1, npcsfl)
 
 !--         aggregate canopy sink factor records with identical box & source
 !--         againg across all values from all processors
-!             CALL radiation_write_debug_log( 'Aggregate canopy sink factor records with identical box' )
+            CALL radiation_write_debug_log( 'Aggregate canopy sink factor records with identical box' )
 
             IF ( npcsfl > 0 )  THEN
@@ -6190,10 +6867,5 @@
                          kpcsflt(1,icsf) == kpcsflt(1,icsf+1)  .AND.  &
                          kpcsflt(4,icsf) == kpcsflt(4,icsf+1) )  THEN
-!--                     We could simply take either first or second rtransp, both are valid. As a very simple heuristic about which ray
-!--                     probably passes nearer the center of the target box, we choose DIF from the entry with greater CSF, since that
-!--                     might mean that the traced beam passes longer through the canopy box.
-                        IF ( pcsflt(1,kcsf) < pcsflt(1,icsf+1) )  THEN
-                            pcsflt(2,kcsf) = pcsflt(2,icsf+1)
-                        ENDIF
+
                         pcsflt(1,kcsf) = pcsflt(1,kcsf) + pcsflt(1,icsf+1)
 
@@ -6224,7 +6896,8 @@
             
 !--         deallocation of temporary arrays
-            DEALLOCATE( pcsflt )
-            DEALLOCATE( kpcsflt )
-!             CALL radiation_write_debug_log( 'End of aggregate csf' )
+            IF ( npcbl > 0 )  DEALLOCATE( gridpcbl )
+            DEALLOCATE( pcsflt_l )
+            DEALLOCATE( kpcsflt_l )
+            CALL radiation_write_debug_log( 'End of aggregate csf' )
             
         ENDIF
@@ -6233,5 +6906,5 @@
         CALL MPI_BARRIER( comm2d, ierr )
 #endif
-!         CALL radiation_write_debug_log( 'End of radiation_calc_svf (after mpi_barrier)' )
+        CALL radiation_write_debug_log( 'End of radiation_calc_svf (after mpi_barrier)' )
 
         RETURN
@@ -6261,5 +6934,5 @@
 !>    doesn't need to be the same in all three dimensions).
 !------------------------------------------------------------------------------!
-    SUBROUTINE raytrace(src, targ, isrc, rirrf, atarg, create_csf, visible, transparency, win_lad)
+    SUBROUTINE raytrace(src, targ, isrc, rirrf, atarg, create_csf, visible, transparency)
         IMPLICIT NONE
 
@@ -6271,5 +6944,4 @@
         LOGICAL, INTENT(out)                   :: visible
         REAL(wp), INTENT(out)                  :: transparency !< along whole path
-        INTEGER(iwp), INTENT(in)               :: win_lad
         INTEGER(iwp)                           :: i, k, d
         INTEGER(iwp)                           :: seldim       !< dimension to be incremented
@@ -6294,5 +6966,4 @@
         INTEGER(iwp)                           :: ig           !< 1D index of gridbox in global 2D array
         REAL(wp)                               :: lad_s_target !< recieved lad_s of particular grid box
-        REAL(wp), PARAMETER                    :: grow_factor = 1.5_wp !< factor of expansion of grow arrays
 
 !
@@ -6385,13 +7056,14 @@
         IF ( plant_canopy )  THEN
 #if defined( __parallel )
-            IF ( rma_lad_raytrace )  THEN
+            IF ( raytrace_mpi_rma )  THEN
 !--             send requests for lad_s to appropriate processor
-                CALL cpu_log( log_point_s(77), 'rad_init_rma', 'start' )
+                CALL cpu_log( log_point_s(77), 'rad_rma_lad', 'start' )
                 DO i = 1, ncsb
                     CALL MPI_Get(lad_s_ray(i), 1, MPI_REAL, lad_ip(i), lad_disp(i), &
                                  1, MPI_REAL, win_lad, ierr)
                     IF ( ierr /= 0 )  THEN
-                        WRITE(message_string, *) 'MPI error ', ierr, ' at MPI_Get'
-                        CALL message( 'raytrace', 'PA0519', 1, 2, 0, 6, 0 )
+                        WRITE(9,*) 'Error MPI_Get1:', ierr, lad_s_ray(i), &
+                                   lad_ip(i), lad_disp(i), win_lad
+                        FLUSH(9)
                     ENDIF
                 ENDDO
@@ -6400,8 +7072,8 @@
                 CALL MPI_Win_flush_local_all(win_lad, ierr)
                 IF ( ierr /= 0 )  THEN
-                    WRITE(message_string, *) 'MPI error ', ierr, ' at MPI_Win_flush_local_all'
-                    CALL message( 'raytrace', 'PA0519', 1, 2, 0, 6, 0 )
+                    WRITE(9,*) 'Error MPI_Win_flush_local_all1:', ierr, win_lad
+                    FLUSH(9)
                 ENDIF
-                CALL cpu_log( log_point_s(77), 'rad_init_rma', 'stop' )
+                CALL cpu_log( log_point_s(77), 'rad_rma_lad', 'stop' )
                 
             ENDIF
@@ -6411,5 +7083,5 @@
             DO i = 1, ncsb
 #if defined( __parallel )
-                IF ( rma_lad_raytrace )  THEN
+                IF ( raytrace_mpi_rma )  THEN
                     lad_s_target = lad_s_ray(i)
                 ELSE
@@ -6429,6 +7101,5 @@
                     acsf(ncsfl)%itz = boxes(1,i)
                     acsf(ncsfl)%isurfs = isrc
-                    acsf(ncsfl)%rsvf = REAL(cursink*rirrf*atarg, wp) !-- we postpone multiplication by transparency
-                    acsf(ncsfl)%rtransp = REAL(transparency, wp)
+                    acsf(ncsfl)%rsvf = cursink*transparency*rirrf*atarg
                 ENDIF  !< create_csf
 
@@ -6452,24 +7123,25 @@
 !> vertical_delta / horizontal_distance
 !------------------------------------------------------------------------------!
-   SUBROUTINE raytrace_2d(origin, yxdir, zdirs, iorig, aorig, vffrac, &
-                              create_csf, skip_1st_pcb, win_lad, horizon, &
-                              transparency)
+   SUBROUTINE raytrace_2d(origin, yxdir, nrays, zdirs, iorig, aorig, vffrac,  &
+                              calc_svf, create_csf, skip_1st_pcb,             &
+                              lowest_free_ray, transparency, itarget)
       IMPLICIT NONE
 
       REAL(wp), DIMENSION(3), INTENT(IN)     ::  origin        !< z,y,x coordinates of ray origin
       REAL(wp), DIMENSION(2), INTENT(IN)     ::  yxdir         !< y,x *unit* vector of ray direction (in grid units)
-      REAL(wp), DIMENSION(:), INTENT(IN)     ::  zdirs         !< list of z directions to raytrace (z/hdist, in grid)
+      INTEGER(iwp)                           ::  nrays         !< number of rays (z directions) to raytrace
+      REAL(wp), DIMENSION(nrays), INTENT(IN) ::  zdirs         !< list of z directions to raytrace (z/hdist, grid, zenith->nadir)
       INTEGER(iwp), INTENT(in)               ::  iorig         !< index of origin face for csf
       REAL(wp), INTENT(in)                   ::  aorig         !< origin face area for csf
-      REAL(wp), DIMENSION(LBOUND(zdirs, 1):UBOUND(zdirs, 1)), INTENT(in) ::  vffrac !< 
-                                                               !< view factor fractions of each ray for csf
-      LOGICAL, INTENT(in)                    ::  create_csf    !< whether to generate new CSFs during raytracing
+      REAL(wp), DIMENSION(nrays), INTENT(in) ::  vffrac        !< view factor fractions of each ray for csf
+      LOGICAL, INTENT(in)                    ::  calc_svf      !< whether to calculate SFV (identify obstacle surfaces)
+      LOGICAL, INTENT(in)                    ::  create_csf    !< whether to create canopy sink factors
       LOGICAL, INTENT(in)                    ::  skip_1st_pcb  !< whether to skip first plant canopy box during raytracing
-      INTEGER(iwp), INTENT(in)               ::  win_lad       !< leaf area density MPI window
-      REAL(wp), INTENT(OUT)                  ::  horizon       !< highest horizon found after raytracing (z/hdist)
-      REAL(wp), DIMENSION(LBOUND(zdirs, 1):UBOUND(zdirs, 1)), INTENT(OUT) ::  transparency !<
-                                                                !< transparencies of zdirs paths
-      !--INTEGER(iwp), DIMENSION(3, LBOUND(zdirs, 1):UBOUND(zdirs, 1)), INTENT(OUT) :: itarget !<
-                                                                !< (z,y,x) coordinates of target faces for zdirs
+      INTEGER(iwp), INTENT(out)              ::  lowest_free_ray !< index into zdirs
+      REAL(wp), DIMENSION(nrays), INTENT(OUT) ::  transparency !< transparencies of zdirs paths
+      INTEGER(iwp), DIMENSION(nrays), INTENT(OUT) ::  itarget  !< global indices of target faces for zdirs
+
+      INTEGER(iwp), DIMENSION(nrays)         ::  target_procs
+      REAL(wp)                               ::  horizon       !< highest horizon found after raytracing (z/hdist)
       INTEGER(iwp)                           ::  i, k, l, d
       INTEGER(iwp)                           ::  seldim       !< dimension to be incremented
@@ -6506,5 +7178,7 @@
       INTEGER(iwp)                           ::  iz
       INTEGER(iwp)                           ::  zsgn
-      REAL(wp), PARAMETER                    ::  grow_factor = 1.5_wp !< factor of expansion of grow arrays
+      INTEGER(iwp)                           ::  lowest_lad   !< lowest column cell for which we need LAD
+      INTEGER(iwp)                           ::  lastdir      !< wall direction before hitting this column
+      INTEGER(iwp), DIMENSION(2)             ::  lastcolumn
 
 #if defined( __parallel )
@@ -6515,6 +7189,13 @@
       transparency(:) = 1._wp !-- Pre-set the all rays to transparent before reducing
       horizon = -HUGE(1._wp)
-
-      !--Determine distance to boundary (in 2D xy)
+      lowest_free_ray = nrays
+      IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
+         ALLOCATE(target_surfl(nrays))
+         target_surfl(:) = -1
+         lastdir = -999
+         lastcolumn(:) = -999
+      ENDIF
+
+!--   Determine distance to boundary (in 2D xy)
       IF ( yxdir(1) > 0._wp )  THEN
          bdydim = ny + .5_wp !< north global boundary
@@ -6548,5 +7229,5 @@
 !--   Since all face coordinates have values *.5 and we'd like to use
 !--   integers, all these have .5 added
-      DO d = 1, 2
+      DO  d = 1, 2
           IF ( yxdir(d) == 0._wp )  THEN
               dimnext(d) = HUGE(1_iwp)
@@ -6569,10 +7250,10 @@
          seldim = minloc(dimnextdist, 1)
          nextdist = dimnextdist(seldim)
-         IF ( nextdist > distance ) nextdist = distance
+         IF ( nextdist > distance )  nextdist = distance
 
          IF ( nextdist > lastdist )  THEN
             ntrack = ntrack + 1
             crmid = (lastdist + nextdist) * .5_wp
-            column = INT(yxorigin(:) + yxdir(:) * crmid, iwp)  !NINT(yxorigin(:) + yxdir(:) * crmid, iwp) 
+            column = NINT(yxorigin(:) + yxdir(:) * crmid, iwp)
 
 !--         calculate index of the grid with global indices (column(1),column(2))
@@ -6586,7 +7267,32 @@
                horz_entry = -HUGE(1._wp)
             ELSE
-               horz_entry = (nzterr(ig) - origin(1)) / lastdist
+               horz_entry = (REAL(nzterr(ig), wp) + .5_wp - origin(1)) / lastdist
             ENDIF
-            horz_exit = (nzterr(ig) - origin(1)) / nextdist
+            horz_exit = (REAL(nzterr(ig), wp) + .5_wp - origin(1)) / nextdist
+
+            IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
+!
+!--            Identify vertical obstacles hit by rays in current column
+               DO WHILE ( lowest_free_ray > 0 )
+                  IF ( zdirs(lowest_free_ray) > horz_entry )  EXIT
+!
+!--               This may only happen after 1st column, so lastdir and lastcolumn are valid
+                  CALL request_itarget(lastdir,                                         &
+                        CEILING(-0.5_wp + origin(1) + zdirs(lowest_free_ray)*lastdist), &
+                        lastcolumn(1), lastcolumn(2),                                   &
+                        target_surfl(lowest_free_ray), target_procs(lowest_free_ray))
+                  lowest_free_ray = lowest_free_ray - 1
+               ENDDO
+!
+!--            Identify horizontal obstacles hit by rays in current column
+               DO WHILE ( lowest_free_ray > 0 )
+                  IF ( zdirs(lowest_free_ray) > horz_exit )  EXIT
+                  CALL request_itarget(iup_u, nzterr(ig)+1, column(1), column(2), &
+                                       target_surfl(lowest_free_ray),           &
+                                       target_procs(lowest_free_ray))
+                  lowest_free_ray = lowest_free_ray - 1
+               ENDDO
+            ENDIF
+
             horizon = MAX(horizon, horz_entry, horz_exit)
 
@@ -6598,4 +7304,23 @@
 
          IF ( nextdist >= distance )  EXIT
+
+         IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
+!
+!--         Save wall direction of coming building column (= this air column)
+            IF ( seldim == 1 )  THEN
+               IF ( dimdelta(seldim) == 1 )  THEN
+                  lastdir = isouth_u
+               ELSE
+                  lastdir = inorth_u
+               ENDIF
+            ELSE
+               IF ( dimdelta(seldim) == 1 )  THEN
+                  lastdir = iwest_u
+               ELSE
+                  lastdir = ieast_u
+               ENDIF
+            ENDIF
+            lastcolumn = column
+         ENDIF
          lastdist = nextdist
          dimnext(seldim) = dimnext(seldim) + dimdelta(seldim)
@@ -6604,24 +7329,41 @@
 
       IF ( plant_canopy )  THEN
-         !--Request LAD WHERE applicable
-         !--
+!--      Request LAD WHERE applicable
+!--      
 #if defined( __parallel )
-         IF ( rma_lad_raytrace )  THEN
+         IF ( raytrace_mpi_rma )  THEN
 !--         send requests for lad_s to appropriate processor
             !CALL cpu_log( log_point_s(77), 'usm_init_rma', 'start' )
-            DO i = 1, ntrack
+            DO  i = 1, ntrack
                px = rt2_track(2,i)/nnx
                py = rt2_track(1,i)/nny
                ip = px*pdims(2)+py
                ig = ip*nnx*nny + (rt2_track(2,i)-px*nnx)*nny + rt2_track(1,i)-py*nny
-               IF ( plantt(ig) <= nzterr(ig) )  CYCLE
-               wdisp = (rt2_track(2,i)-px*nnx)*(nny*nzp) + (rt2_track(1,i)-py*nny)*nzp + nzterr(ig)+1-nzub
-               wcount = plantt(ig)-nzterr(ig)
+
+               IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
+!
+!--               For fixed view resolution, we need plant canopy even for rays
+!--               to opposing surfaces
+                  lowest_lad = nzterr(ig) + 1
+               ELSE
+!
+!--               We only need LAD for rays directed above horizon (to sky)
+                  lowest_lad = CEILING( -0.5_wp + origin(1) +            &
+                                    MIN( horizon * rt2_track_dist(i-1),  & ! entry
+                                         horizon * rt2_track_dist(i)   ) ) ! exit
+               ENDIF
+!
+!--            Skip asking for LAD where all plant canopy is under requested level
+               IF ( plantt(ig) < lowest_lad )  CYCLE
+
+               wdisp = (rt2_track(2,i)-px*nnx)*(nny*nzp) + (rt2_track(1,i)-py*nny)*nzp + lowest_lad-nzub
+               wcount = plantt(ig)-lowest_lad+1
                ! TODO send request ASAP - even during raytracing
-               CALL MPI_Get(rt2_track_lad(nzterr(ig)+1:plantt(ig), i), wcount, MPI_REAL, ip,    &
+               CALL MPI_Get(rt2_track_lad(lowest_lad:plantt(ig), i), wcount, MPI_REAL, ip,    &
                             wdisp, wcount, MPI_REAL, win_lad, ierr)
                IF ( ierr /= 0 )  THEN
-                  WRITE(message_string, *) 'MPI error ', ierr, ' at MPI_Get'
-                  CALL message( 'raytrace_2d', 'PA0526', 1, 2, 0, 6, 0 )
+                  WRITE(9,*) 'Error MPI_Get2:', ierr, rt2_track_lad(lowest_lad:plantt(ig), i), &
+                             wcount, ip, wdisp, win_lad
+                  FLUSH(9)
                ENDIF
             ENDDO
@@ -6631,10 +7373,11 @@
             CALL MPI_Win_flush_local_all(win_lad, ierr)
             IF ( ierr /= 0 )  THEN
-               WRITE(message_string, *) 'MPI error ', ierr, ' at MPI_Win_flush_local_all'
-               CALL message( 'raytrace', 'PA0527', 1, 2, 0, 6, 0 )
+               WRITE(9,*) 'Error MPI_Win_flush_local_all2:', ierr, win_lad
+               FLUSH(9)
             ENDIF
             !CALL cpu_log( log_point_s(77), 'usm_init_rma', 'stop' )
-         ELSE ! rma_lad_raytrace
-            DO i = 1, ntrack
+
+         ELSE ! raytrace_mpi_rma = .F.
+            DO  i = 1, ntrack
                px = rt2_track(2,i)/nnx
                py = rt2_track(1,i)/nny
@@ -6645,18 +7388,46 @@
          ENDIF
 #else
-         DO i = 1, ntrack
+         DO  i = 1, ntrack
             rt2_track_lad(nzub:plantt_max, i) = sub_lad(rt2_track(1,i), rt2_track(2,i), nzub:plantt_max)
          ENDDO
 #endif
-
-         !--Skip the PCB around origin if requested
-         !--
-         IF ( skip_1st_pcb )  THEN
+      ENDIF ! plant_canopy
+
+      IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
+#if defined( __parallel )
+!--      wait for all gridsurf requests to complete
+         CALL MPI_Win_flush_local_all(win_gridsurf, ierr)
+         IF ( ierr /= 0 )  THEN
+            WRITE(9,*) 'Error MPI_Win_flush_local_all3:', ierr, win_gridsurf
+            FLUSH(9)
+         ENDIF
+#endif
+!
+!--      recalculate local surf indices into global ones
+         DO i = 1, nrays
+            IF ( target_surfl(i) == -1 )  THEN
+               itarget(i) = -1
+            ELSE
+               itarget(i) = target_surfl(i) + surfstart(target_procs(i))
+            ENDIF
+         ENDDO
+         
+         DEALLOCATE( target_surfl )
+         
+      ELSE
+         itarget(:) = -1
+      ENDIF ! rad_angular_discretization
+
+      IF ( plant_canopy )  THEN
+!--      Skip the PCB around origin if requested (for MRT, the PCB might not be there)
+!--      
+         IF ( skip_1st_pcb  .AND.  NINT(origin(1)) <= plantt_max )  THEN
             rt2_track_lad(NINT(origin(1), iwp), 1) = 0._wp
          ENDIF
 
-         !--Assert that we have space allocated for CSFs
-         !--
-         maxboxes = (ntrack + MAX(origin(1) - nzub, nzut - origin(1))) * SIZE(zdirs, 1)
+!--      Assert that we have space allocated for CSFs
+!--      
+         maxboxes = (ntrack + MAX(CEILING(origin(1)-.5_wp) - nzub,          &
+                                  nzpt - CEILING(origin(1)-.5_wp))) * nrays
          IF ( ncsfl + maxboxes > ncsfla )  THEN
 !--         use this code for growing by fixed exponential increments (equivalent to case where ncsfl always increases by 1)
@@ -6668,13 +7439,13 @@
          ENDIF
 
-         !--Calculate transparencies and store new CSFs
-         !--
+!--      Calculate transparencies and store new CSFs
+!--      
          zbottom = REAL(nzub, wp) - .5_wp
          ztop = REAL(plantt_max, wp) + .5_wp
 
-         !--Reverse direction of radiation (face->sky), only when create_csf
-         !--
-         IF ( create_csf )  THEN
-            DO i = 1, ntrack ! for each column
+!--      Reverse direction of radiation (face->sky), only when calc_svf
+!--      
+         IF ( calc_svf )  THEN
+            DO  i = 1, ntrack ! for each column
                dxxyy = ((dy*yxdir(1))**2 + (dx*yxdir(2))**2) * (rt2_track_dist(i)-rt2_track_dist(i-1))**2
                px = rt2_track(2,i)/nnx
@@ -6682,11 +7453,23 @@
                ip = px*pdims(2)+py
 
-               DO k = LBOUND(zdirs, 1), UBOUND(zdirs, 1) ! for each ray
-                  IF ( zdirs(k) <= horizon )  THEN
-                     CYCLE
+               DO  k = 1, nrays ! for each ray
+!
+!--               NOTE 6778:
+!--               With traditional svf discretization, CSFs under the horizon
+!--               (i.e. for surface to surface radiation)  are created in
+!--               raytrace(). With rad_angular_discretization, we must create
+!--               CSFs under horizon only for one direction, otherwise we would
+!--               have duplicate amount of energy. Although we could choose
+!--               either of the two directions (they differ only by
+!--               discretization error with no bias), we choose the the backward
+!--               direction, because it tends to cumulate high canopy sink
+!--               factors closer to raytrace origin, i.e. it should potentially
+!--               cause less moiree.
+                  IF ( .NOT. rad_angular_discretization )  THEN
+                     IF ( zdirs(k) <= horizon )  CYCLE
                   ENDIF
 
-                  zorig = REAL(origin(1), wp) + zdirs(k) * rt2_track_dist(i-1)
-                  IF ( zorig <= zbottom .OR. zorig >= ztop )  CYCLE
+                  zorig = origin(1) + zdirs(k) * rt2_track_dist(i-1)
+                  IF ( zorig <= zbottom  .OR.  zorig >= ztop )  CYCLE
 
                   zsgn = INT(SIGN(1._wp, zdirs(k)), iwp)
@@ -6695,7 +7478,7 @@
                      nz = 2
                      rt2_dist(nz) = SQRT(dxxyy)
-                     iz = NINT(zorig, iwp)
+                     iz = CEILING(-.5_wp + zorig, iwp)
                   ELSE
-                     zexit = MIN(MAX(REAL(origin(1), wp) + zdirs(k) * rt2_track_dist(i), zbottom), ztop)
+                     zexit = MIN(MAX(origin(1) + zdirs(k) * rt2_track_dist(i), zbottom), ztop)
 
                      zb0 = FLOOR(  zorig * zsgn - .5_wp) + 1  ! because it must be greater than orig
@@ -6708,15 +7491,17 @@
                   ENDIF
 
-                  DO l = 2, nz
+                  DO  l = 2, nz
                      IF ( rt2_track_lad(iz, i) > 0._wp )  THEN
                         curtrans = exp(-ext_coef * rt2_track_lad(iz, i) * (rt2_dist(l)-rt2_dist(l-1)))
-                        ncsfl = ncsfl + 1
-                        acsf(ncsfl)%ip = ip
-                        acsf(ncsfl)%itx = rt2_track(2,i)
-                        acsf(ncsfl)%ity = rt2_track(1,i)
-                        acsf(ncsfl)%itz = iz
-                        acsf(ncsfl)%isurfs = iorig
-                        acsf(ncsfl)%rsvf = REAL((1._wp - curtrans)*aorig*vffrac(k), wp) ! we postpone multiplication by transparency
-                        acsf(ncsfl)%rtransp = REAL(transparency(k), wp)
+
+                        IF ( create_csf )  THEN
+                           ncsfl = ncsfl + 1
+                           acsf(ncsfl)%ip = ip
+                           acsf(ncsfl)%itx = rt2_track(2,i)
+                           acsf(ncsfl)%ity = rt2_track(1,i)
+                           acsf(ncsfl)%itz = iz
+                           acsf(ncsfl)%isurfs = iorig
+                           acsf(ncsfl)%rsvf = (1._wp - curtrans)*transparency(k)*aorig*vffrac(k)
+                        ENDIF
 
                         transparency(k) = transparency(k) * curtrans
@@ -6724,13 +7509,13 @@
                      iz = iz + zsgn
                   ENDDO ! l = 1, nz - 1
-               ENDDO ! k = LBOUND(zdirs, 1), UBOUND(zdirs, 1)
+               ENDDO ! k = 1, nrays
             ENDDO ! i = 1, ntrack
 
-            transparency(:) = 1._wp !-- Reset all rays to transparent
+            transparency(1:lowest_free_ray) = 1._wp !-- Reset rays above horizon to transparent (see NOTE 6778)
          ENDIF
 
-         !-- Forward direction of radiation (sky->face), always
-         !--
-         DO i = ntrack, 1, -1 ! for each column backwards
+!--      Forward direction of radiation (sky->face), always
+!--      
+         DO  i = ntrack, 1, -1 ! for each column backwards
             dxxyy = ((dy*yxdir(1))**2 + (dx*yxdir(2))**2) * (rt2_track_dist(i)-rt2_track_dist(i-1))**2
             px = rt2_track(2,i)/nnx
@@ -6738,12 +7523,11 @@
             ip = px*pdims(2)+py
 
-            DO k = LBOUND(zdirs, 1), UBOUND(zdirs, 1) ! for each ray
-               IF ( zdirs(k) <= horizon )  THEN
-                  transparency(k) = 0._wp
-                  CYCLE
-               ENDIF
-
-               zexit = REAL(origin(1), wp) + zdirs(k) * rt2_track_dist(i-1)
-               IF ( zexit <= zbottom .OR. zexit >= ztop )  CYCLE
+            DO  k = 1, nrays ! for each ray
+!
+!--            See NOTE 6778 above
+               IF ( zdirs(k) <= horizon )  CYCLE
+
+               zexit = origin(1) + zdirs(k) * rt2_track_dist(i-1)
+               IF ( zexit <= zbottom  .OR.  zexit >= ztop )  CYCLE
 
                zsgn = -INT(SIGN(1._wp, zdirs(k)), iwp)
@@ -6754,5 +7538,5 @@
                   iz = NINT(zexit, iwp)
                ELSE
-                  zorig = MIN(MAX(REAL(origin(1), wp) + zdirs(k) * rt2_track_dist(i), zbottom), ztop)
+                  zorig = MIN(MAX(origin(1) + zdirs(k) * rt2_track_dist(i), zbottom), ztop)
 
                   zb0 = FLOOR(  zorig * zsgn - .5_wp) + 1  ! because it must be greater than orig
@@ -6765,5 +7549,5 @@
                ENDIF
 
-               DO l = 2, nz
+               DO  l = 2, nz
                   IF ( rt2_track_lad(iz, i) > 0._wp )  THEN
                      curtrans = exp(-ext_coef * rt2_track_lad(iz, i) * (rt2_dist(l)-rt2_dist(l-1)))
@@ -6775,8 +7559,8 @@
                         acsf(ncsfl)%ity = rt2_track(1,i)
                         acsf(ncsfl)%itz = iz
-                        acsf(ncsfl)%isurfs = -1 ! a special ID indicating sky
-                        acsf(ncsfl)%rsvf = REAL((1._wp - curtrans)*aorig*vffrac(k), wp) ! we postpone multiplication by transparency
-                        acsf(ncsfl)%rtransp = REAL(transparency(k), wp)
-                     ENDIF  !< create_csf
+                        acsf(ncsfl)%isurfs = itarget(k) !if above horizon, then itarget(k)==-1, which
+                                                        !is also a special ID indicating sky
+                        acsf(ncsfl)%rsvf = (1._wp - curtrans)*transparency(k)*aorig*vffrac(k)
+                     ENDIF  ! create_csf
 
                      transparency(k) = transparency(k) * curtrans
@@ -6784,13 +7568,45 @@
                   iz = iz + zsgn
                ENDDO ! l = 1, nz - 1
-            ENDDO ! k = LBOUND(zdirs, 1), UBOUND(zdirs, 1)
+            ENDDO ! k = 1, nrays
          ENDDO ! i = 1, ntrack
-
-      ELSE ! not plant_canopy
-         DO k = UBOUND(zdirs, 1), LBOUND(zdirs, 1), -1 ! TODO make more generic
-            IF ( zdirs(k) > horizon )  EXIT
-            transparency(k) = 0._wp
+      ENDIF ! plant_canopy
+
+      IF ( .NOT. (rad_angular_discretization  .AND.  calc_svf) )  THEN
+!
+!--      Just update lowest_free_ray according to horizon
+         DO WHILE ( lowest_free_ray > 0 )
+            IF ( zdirs(lowest_free_ray) > horizon )  EXIT
+            lowest_free_ray = lowest_free_ray - 1
          ENDDO
       ENDIF
+
+   CONTAINS
+      SUBROUTINE request_itarget(d, z, y, x, isurfl, iproc)
+         INTEGER(iwp), INTENT(in)            ::  d, z, y, x
+         INTEGER(iwp), TARGET, INTENT(out)   ::  isurfl
+         INTEGER(iwp), INTENT(out)           ::  iproc
+         INTEGER(kind=MPI_ADDRESS_KIND)      ::  target_displ  !< index of the grid in the local gridsurf array
+         INTEGER(iwp)                        ::  px, py        !< number of processors in x and y direction
+                                                               !< before the processor in the question
+
+!--      calculate target processor and index in the remote local target gridsurf array
+         px = x/nnx
+         py = y/nny
+         iproc = px*pdims(2)+py
+         target_displ = ((x-px*nnx)*nny + y-py*nny)*nzu*nsurf_type_u + (z-nzub)*nsurf_type_u + d
+
+#if defined( __parallel )
+!--      send MPI_Get request to obtain index target_surfl(i)
+         CALL MPI_Get(isurfl, 1, MPI_INTEGER, iproc, target_displ, &
+                        1, MPI_INTEGER, win_gridsurf, ierr)
+         IF ( ierr /= 0 )  THEN
+            WRITE(9,*) 'Error MPI_Get3:', ierr, isurfl, iproc, target_displ, win_gridsurf
+            FLUSH(9)
+         ENDIF
+#else
+!--      set index target_surfl(i)
+         isurfl = gridsurf(d,z,y,x)
+#endif
+      END SUBROUTINE request_itarget
 
    END SUBROUTINE raytrace_2d
@@ -6849,4 +7665,5 @@
       ALLOCATE ( dsitrans(nsurfl, ndsidir) )
       ALLOCATE ( dsitransc(npcbl, ndsidir) )
+      IF ( nmrtbl > 0 )  ALLOCATE ( mrtdsit(nmrtbl, ndsidir) )
 
       WRITE ( message_string, * ) 'Precalculated', ndsidir, ' solar positions', &
@@ -6905,28 +7722,26 @@
 
 !-- first check: are the two surfaces directed in the same direction
-        IF ( (d==iup_u  .OR.  d==iup_l  .OR.  d==iup_a )                             &
+        IF ( (d==iup_u  .OR.  d==iup_l )                             &
              .AND. (d2==iup_u  .OR. d2==iup_l) ) RETURN
-        IF ( (d==isouth_u  .OR.  d==isouth_l  .OR.  d==isouth_a ) &
+        IF ( (d==isouth_u  .OR.  d==isouth_l ) &
              .AND.  (d2==isouth_u  .OR.  d2==isouth_l) ) RETURN
-        IF ( (d==inorth_u  .OR.  d==inorth_l  .OR.  d==inorth_a ) &
+        IF ( (d==inorth_u  .OR.  d==inorth_l ) &
              .AND.  (d2==inorth_u  .OR.  d2==inorth_l) ) RETURN
-        IF ( (d==iwest_u  .OR.  d==iwest_l  .OR.  d==iwest_a )     &
+        IF ( (d==iwest_u  .OR.  d==iwest_l )     &
              .AND.  (d2==iwest_u  .OR.  d2==iwest_l ) ) RETURN
-        IF ( (d==ieast_u  .OR.  d==ieast_l  .OR.  d==ieast_a )     &
+        IF ( (d==ieast_u  .OR.  d==ieast_l )     &
              .AND.  (d2==ieast_u  .OR.  d2==ieast_l ) ) RETURN
 
 !-- second check: are surfaces facing away from each other
         SELECT CASE (d)
-            CASE (iup_u, iup_l, iup_a)              !< upward facing surfaces
+            CASE (iup_u, iup_l)                     !< upward facing surfaces
                 IF ( z2 < z ) RETURN
-            CASE (idown_a)                          !< downward facing surfaces
-                IF ( z2 > z ) RETURN
-            CASE (isouth_u, isouth_l, isouth_a)     !< southward facing surfaces
+            CASE (isouth_u, isouth_l)               !< southward facing surfaces
                 IF ( y2 > y ) RETURN
-            CASE (inorth_u, inorth_l, inorth_a)     !< northward facing surfaces
+            CASE (inorth_u, inorth_l)               !< northward facing surfaces
                 IF ( y2 < y ) RETURN
-            CASE (iwest_u, iwest_l, iwest_a)        !< westward facing surfaces
+            CASE (iwest_u, iwest_l)                 !< westward facing surfaces
                 IF ( x2 > x ) RETURN
-            CASE (ieast_u, ieast_l, ieast_a)        !< eastward facing surfaces
+            CASE (ieast_u, ieast_l)                 !< eastward facing surfaces
                 IF ( x2 < x ) RETURN
         END SELECT
